/*****************************************************
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <math.h>
#include <astro_math.c>


// Declare your global variables here  
#define light_on  PORTC.5=1;
#define light_off PORTC.5=0;


unsigned char Ok=27, Down=29, Up=30, key=31;

      
#define dig1 PORTB.1      
#define dig2 PORTB.2      
#define dig3 PORTB.3 
#define dig4 PORTB.4
#define DP   PORTD.7


flash char digits[] = {       
0b00111111,                   //0
0b00000110,                   //1
0b01011011,                   //2
0b01001111,                   //3
0b01100110,                   //4
0b01101101,                   //5
0b01111101,                   //6
0b00000111,                   //7
0b01111111,                   //8
0b01101111,                   //9
0b00111000,                   //L
0b01010100,                   //n
0b01111000,                   //t
0b00111001,                   //C
0b01011100,                   //o
0b00110011,                   //M
0b00100111,                   //M
};


// Declare your global variables here

unsigned char digit_buff[4];

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
    key=PINC & 0b00011111;// 
}

// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here
  sec++; //  
}


void me_delay(void)
{
  while (key!=31) {key=PINC & 0b00011111; delay_ms(10);}; 
}


// Declare your global variables here



 void recode_time(void) 
 {       
   digit_buff[0]=digits[(hr/10)%10];        
   digit_buff[1]=digits[hr%10];     
   digit_buff[2]=digits[(mins/10)%10];     
   digit_buff[3]=digits[mins%10];     
 } 


void sun_info()          
{ 
/*  lcd_gotoxy(0,0);
  lcd_putchar (HH[0]/10%10+0x30);
  lcd_putchar (HH[0]%10+0x30);
  lcd_putchar (':');
  lcd_putchar (MM[0]/10%10+0x30);
  lcd_putchar (MM[0]%10+0x30);
  lcd_putchar (' ');
  lcd_putchar (HH[1]/10%10+0x30);
  lcd_putchar (HH[1]%10+0x30);
  lcd_putchar (':');
  lcd_putchar (MM[1]/10%10+0x30);
  lcd_putchar (MM[1]%10+0x30);*/    
}


void display(void)
{ 
  PORTB=0b00011100;
  PORTD=digit_buff[0];
  delay_ms(8);

  PORTB=0b00011010;
  PORTD=digit_buff[1];
  delay_ms(8);

  PORTB=0b00010110;
  PORTD=digit_buff[2];
  delay_ms(8);

  PORTB=0b00001110;
  PORTD=digit_buff[3];
  delay_ms(8);  

//  PORTD=0b00011110;
//  delay_ms(3);  
/*  lcd_gotoxy(13,0); //13
  lcd_putsf("Z");
  lcd_putchar (H/10%10+0x30);
  lcd_putchar (H%10+0x30);
  lcd_gotoxy(0,1);
  lcd_putchar (hr/10%10+0x30);
  lcd_putchar (hr%10+0x30);
  lcd_putchar (delim);
  lcd_putchar (mins/10%10+0x30);
  lcd_putchar (mins%10+0x30);
  lcd_putsf (" ");
  lcd_putchar ((day/10)%10+0x30);
  lcd_putchar (day%10+0x30);
  lcd_putsf ("/");
  lcd_putchar ((M/10)%10+0x30);
  lcd_putchar (M%10+0x30);
  lcd_putsf ("/");
  lcd_putchar ((Y/1000)%10+0x30);
  lcd_putchar ((Y/100)%10+0x30);
  lcd_putchar ((Y/10)%10+0x30);
  lcd_putchar (Y%10+0x30);*/
}


void clock(void)
{ unsigned char qty_days;
//  if (sec%2==0) {DP=1;} else {DP=0;};  
  if (sec==60) //   60
  {
    sec=0; 
    mins++; 
  } else 
  {
    return; //,       
  };
  if (mins==60) {mins=0; hr++;};//   60
  if (hr==24) {day++; hr=0; show_info();};//   24
  qty_days=days_month[M-1];//   
  if ((M==2) && (Y%4)==(Y/4)) {qty_days = 29;}//   
  if (day>qty_days) {M++; day=1; change=0;};//       
  
  if ((M==3) && (day==time_mart) && (change==0)) //    
  {                                                      //   
    if (hr==1)                                           //   
    {
      hr++;                                              //   
      change=1;                                          //    
    }
  };

  if ((M==10) && (day==time_octb) && (change==0)) //    
  {                                                       //   
    if (hr==1)                                            //  
    {
      hr--;                                               //   
      change=1;                                           //    
    }
  };
       
  if (M>12) {M=1; Y++;};// e  12
  recode_time(); //       
}
    
 void on_of_led(void)
  {  
    long int time_dn, time_up, time_now;//       
    time_up=(HH[0]*60 + MM[0]) - cor;// cor     
    time_dn=(HH[1]*60 + MM[1]) + cor;// cor    
    time_now=(long int)hr*60 + mins;
    if (st==1) {light_on;} else
    if ((time_now>=time_up)&&(time_now<=time_dn)) {light_off;}  //   T > T   T < T  
    else {light_on;};// ,   ,   .    ,
    //    
  }
 
void keypress(unsigned char ind, long int ddey, int ga, int gb, char sw) 
{
  while (key!=Ok)
  { 
    if (sw==1)
    {
      digit_buff[2]=digits[ddey/10%10];
      digit_buff[3]=digits[ddey%10];
      display();
    }
    else 
    {  
      display();
    } 
    if ((key==Up) & (ddey<ga)) {ddey++; delay_ms(200);}
    if ((key==Down) & (ddey>gb)) {ddey--; delay_ms(200);}
    if (ind==1) {B5=ddey;}   
    if (ind==2) {lat=(float)ddey;}
    if (ind==3) {M=ddey;}
    if (ind==4) {day=ddey;}
    if (ind==5) {Y=ddey;}
    if (ind==6) {hr=ddey;}  
    if (ind==7) {mins=ddey;} 
    if (ind==8) {cor=ddey;}
    if (ind==9) {H=ddey;} 
  }
  me_delay(); 
}

void menu(void)
{
  digit_buff[0]=digits[10];
  digit_buff[1]=digits[11]; 
  keypress(1, B5, 90, 0, 1); 

  digit_buff[0]=digits[10];
  digit_buff[1]=digits[12];
  keypress(2, lat, 180, 0, 1); 

  digit_buff[0]=digits[2];
  digit_buff[1]=digits[11]; 
  keypress(9, H, 12, 0, 1);

  digit_buff[0]=digits[13];
  digit_buff[1]=digits[14];
  keypress(8, cor, 59, 0, 1);  //

  digit_buff[0]=digits[15];
  digit_buff[1]=digits[16];
  keypress(3, M, 12, 1, 0); 

//  lcd_putsf(msg6);
  keypress(4, day, days_month[M-1], 1, 0); 

//  lcd_putsf(msg7);
  keypress(5, Y, 2100, 2000, 0); 

//  lcd_putsf(msg8); 
  keypress(6, hr, 23, 0, 0); 

//  lcd_putsf(msg9);
  keypress(7, mins, 59, 0, 0);

  sec=0;
  change=0; // 
  display();
}


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=In 
// State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=T 
PORTB=0x00;
DDRB=0x1E;

// Port C initialization
// Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=0 State4=P State3=P State2=P State1=P State0=P 
PORTC=0x1F;
DDRC=0x20;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x04;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: TOSC1 pin
// Clock value: PCK2/128
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x08;
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x41;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")


//while (key!=Ok){lcd_gotoxy(0,0); lcd_putsf(info);}
me_delay();

menu();      
show_info();
recode_time();    

while (1)
      {
      // Place your code here
          if (key !=31) {me_delay(); menu(); show_info();};
          clock();
          display(); 
          on_of_led();
      };
}
